part of tecfy_core_client_package;

abstract class IEntityTransaction {
  /// executed before adding new object
  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeAdd(
          BuildContext? context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  /// executed before update object
  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeUpdate(
          BuildContext? context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  /// executed before delete object
  FutureOr<OperationResultEntityTransaction<Map<String, dynamic>>> beforeDelete(
          BuildContext? context, String id) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterAdd(
          BuildContext? context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterUpdate(
          BuildContext? context, Map<String, dynamic> data) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResultEntityTransaction> afterDelete(
          BuildContext? context, String id) =>
      OperationResultEntityTransaction(
          success: true, skip: true, message: 'Built-in function');

  FutureOr<OperationResult<Map<String, dynamic>>> getDataByBarcode(
          BuildContext? context, String barcode, Map<String, dynamic> data) =>
      OperationResult(success: false, message: 'Built-in function');
}

class OperationResultEntityTransaction<T> extends OperationResult<T> {
  bool skip;
  OperationResultEntityTransaction(
      {required bool success, T? data, this.skip = false, String? message})
      : super(data: data, success: success, message: message);
}
