part of tecfy_core_client_package;

class DropdownComponenet extends StatefulWidget {
  final String? label;
  final String? initalValue;
  final List<Map<String, dynamic>>? options;
  final String idProperty;
  final String displayProperty;
  final void Function(String?)? onChanged;
  DropdownComponenet({
    this.label,
    this.options,
    this.initalValue,
    this.onChanged,
    this.idProperty = 'id',
    this.displayProperty = 'name',
  });
  @override
  _DropdownComponenetState createState() => _DropdownComponenetState();
}

class _DropdownComponenetState extends AppState<DropdownComponenet> {
  List<Map<String, dynamic>>? _data;
  String? _value;
  @override
  void initState() {
    _value = widget.initalValue;
    _data = widget.options;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _data == null
        ? Text('${AppLocale.translate(context, 'Loading')}..')
        : DropdownButtonFormField<String>(
            decoration: InputDecoration(
                labelText: widget.label == null ? null : trans(widget.label)),
            value: _value,
            onChanged: (v) {
              _value = v;
              if (widget.onChanged != null) widget.onChanged?.call(v);
              setState(() {});
            },
            items: (_data
                    ?.map<DropdownMenuItem<String>>((item) => DropdownMenuItem(
                          child: Text(item[widget.displayProperty] ??
                              item['display'] ??
                              item['name'] ??
                              item['nameAr'] ??
                              item['nameEn'] ??
                              'N/A'),
                          value: item[widget.idProperty],
                        ))
                    .toList() ??
                [])
              ..add(_value == null
                  ? DropdownMenuItem(
                      child: Container(),
                    )
                  : DropdownMenuItem(
                      child:
                          Text('غير محدد', style: TextStyle(color: Colors.red)),
                      value: null,
                    )),
          );
  }
}
