part of tecfy_core_client_package;

class ReportListPage extends StatefulWidget {
  @override
  _ReportListPageState createState() => _ReportListPageState();
}

class _ReportListPageState extends State<ReportListPage> {
  List<dynamic>? _reports;

  @override
  void initState() {
    _getData();
    super.initState();
  }

  _getData() async {
    var result =
        await TecfyBasicApp.apiService.httpGetDynamic('Report/GetList');
    if (result.success) {
      setState(() {
        _reports = result.data;
      });
    }
  }

  _onPressed(report) async {
    // AppNavigator.navigateTo(context, ()=>ReportFilterPage(report));
    List<EntityFilter> filter = [];
    bool canceled = false;
    if (report['filters'].length > 0) {
      var result = await AppNavigator.showAppDialog(
          context,
          (c) => EntityFilterPage(
              //report['name${LocalConfigService.languagePrefex}'],
              report['filters'].map<Property>((r) {
                print(r);
                var prop = Property.getProperty(r);
                //prop.isVisable = true;
                prop?.isAdd = true;
                prop?.isEdit = true;
                //prop.size = true;
                prop?.isDisplayField = true;
                prop?.isGrid = false;
                prop?.readOnly = false;
                prop?.isRequired = r['isRequired'] ?? false;
                return prop;
              }).toList(),
              []));
      if (result == null) canceled = true;
      if ((result as List<EntityFilter>?) == null)
        result = List.empty(growable: true);
      filter = result
              ?.where((f) =>
                  f.value != null && f.property != null && f.operatorId != null)
              .toList() ??
          [];
    }
    if (!canceled) {
      for (var m in report['filters']) {
        if (m['isRequired'] == true &&
            !filter.any((p) => p.propertyName == m['dbName'])) {
          AppNavigator.showMessage(context, 'Data Missing',
              message: m['nameAr']);
          return;
        }
      }
      AppNavigator.navigateTo(context, () => ReportDetailPage(report, filter));
    } else {
      //Navigator.pop(context);
    }
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(
      context,
      'Reports',
      'report',
      isMobile: LayoutService.isMobile(context),
      child: _reports == null
          ? Center(
              child: CircularProgressIndicator(
                  valueColor:
                      AlwaysStoppedAnimation<Color>(ThemeService.mainColor)))
          : ListView(
              children: _reports
                      ?.map<Widget>(
                        (report) => Container(
                          alignment: Alignment.center,
                          child: Container(
                            height: 50,
                            constraints: BoxConstraints(maxWidth: 300),
                            padding: EdgeInsets.all(5),
                            child: MaterialButton(
                              shape: RoundedRectangleBorder(
                                  borderRadius: BorderRadius.circular(5)),
                              padding: EdgeInsets.all(5),
                              color: ThemeService.mainColor,
                              onPressed: () => _onPressed(report),
                              child: Row(
                                mainAxisAlignment: MainAxisAlignment.start,
                                children: <Widget>[
                                  SizedBox(width: 5),
                                  // isBussy
                                  //     ? Transform.scale(
                                  //         scale: 0.5,
                                  //         child: CircularProgressIndicator(
                                  //           valueColor: AlwaysStoppedAnimation<Color>(
                                  //               ThemeService.textOnMainColor),
                                  //         ))
                                  //     :
                                  Transform.scale(
                                      scale: 0.8,
                                      child: Icon(Icons.print,
                                          color: Colors.white)),
                                  SizedBox(width: 5),
                                  Text(
                                    report['name${LocalConfigService.languagePrefex}'] ??
                                        'N/A',
                                    style: TextStyle(
                                        color: ThemeService.textOnMainColor),
                                  )
                                ],
                              ),
                            ),
                          ),
                        ),
                      )
                      .toList() ??
                  [],
            ),
    );
  }
}
